import java.io.*;

public class UPServerPool {
    private static String    poolpath = "/home/B7D/wfgate/cyoun/Pool/";
    private static String    poolindex = ".index";

    public UPServerPool() {}

    public synchronized boolean put(WFUserInfo w) {
        boolean found = false;
        try {
            FileInputStream istream = new FileInputStream(poolpath + poolindex);
            ObjectInputStream ois = new ObjectInputStream(istream);

            while (!found) 
                if (w.username.equals((String)ois.readObject())) found = true;;
            istream.close();
        } catch (Exception e) {
            System.err.println("Warning UPServerpool: put() Exception-> " + e);
        }
        if (found) return false;

        try {
            // append the new user to the index file
            FileOutputStream ostream = new FileOutputStream(poolpath + poolindex, true);
            ObjectOutputStream oos = new ObjectOutputStream(ostream);
            oos.writeObject(w.username);
            oos.flush();
            ostream.close();

            ostream = new FileOutputStream(poolpath + w.username);
            oos = new ObjectOutputStream(ostream);
            oos.writeObject(w);
            oos.flush();
            ostream.close();

            return true;

        } catch (Exception e) {
            System.err.println("Warning UPServerpool: put() Exception-> " + e);
        }
        return false;
    }

    public synchronized int verify(WFUserPassMessage wfupm) {
        try {
            FileInputStream istream = new FileInputStream(poolpath + wfupm.username);
            ObjectInputStream ois = new ObjectInputStream(istream);
            WFUserInfo w = (WFUserInfo)ois.readObject();
            istream.close();
            if (wfupm.password.equals(w.password)) return (int)1;
        } catch (Exception e) {
            System.err.println("UPServerpool: verify() Exception-> " + e);
        }
        return (int)0;
    }
}

